Program BinaryTernary;
Const MaxN=10000;
Type TNumber = Record
                 n: LongInt;
                 d: Array [0..2*MaxN+2] of Integer;
               End;

Function GetN(var f: Text):TNumber;
Var i, j: LongInt;
    w: ShortInt;
    c: Char;
    x: TNumber;
Begin
  x.n:= -1;
  While not SeekEoLn(f) Do Begin
    Inc(x.n);
    Read(f,c);
    Case c of
    'm': x.d[x.n]:= -1;
    '0': x.d[x.n]:= 0;
    'p': x.d[x.n]:= 1;
    End;
  End;
  i:= 0; j:= x.n;
  While (i<j) Do Begin
    w:= x.d[i]; x.d[i]:= x.d[j]; x.d[j]:= w;
    Inc(i);
    Dec(j);
  End;
  Readln(f);
  GetN:= x;
End;

Procedure PutN(var f: Text; x: TNumber);
Var i: LongInt;
Begin
  For i:= x.n DownTo 0 Do Begin
    Case x.d[i] of
    -1: Write(f,'m');
     0: Write(f,'0');
     1: Write(f,'p');
    End;
  End;
  Writeln(f);
End;

Procedure NormalizeToBin3(var x:TNumber);
Var i: LongInt;
    w: LongInt;
Begin
  For i:= 0 To x.n-2 Do Begin
    w:= x.d[i]+2*x.d[i+1];
    If (w mod 2 = 0) Then Begin
      x.d[i]:= 0;
      x.d[i+1]:= w div 2;
    End
    Else {w - ⭮} Begin
      If ((w-1) mod 4 = 0) Then Begin
        x.d[i]:= 1;
        x.d[i+1]:= 0;
        Inc(x.d[i+2], (w-1) div 4);
      End
      Else {(w+1) mod 4 = 0} Begin
        x.d[i]:= -1;
        x.d[i+1]:= 0;
        Inc(x.d[i+2], (w+1) div 4);
      End
    End;
  End;
  Repeat
    Inc(x.n);
    w:= x.d[x.n-2]+2*x.d[x.n-1];
    If (w mod 2 = 0) Then Begin
      x.d[x.n-2]:= 0;
      x.d[x.n-1]:= w div 2;
      x.d[x.n]:= 0;
    End
    Else {w - ⭮} Begin
      If ((w-1) mod 4 = 0) Then Begin
        x.d[x.n-2]:= 1;
        x.d[x.n-1]:= 0;
        x.d[x.n]:= (w-1) div 4;
      End
      Else {(w+1) mod 4 = 0} Begin
        x.d[x.n-2]:= -1;
        x.d[x.n-1]:= 0;
        x.d[x.n]:= (w+1) div 4;
      End;
    End;
  Until abs(w)<=2;  // <==> (x.d[x.n]=0) and (abs(x.d[x.n-1])<=1);
  While (x.n>0) and (x.d[x.n]=0) Do Dec(x.n);
End;

Function Sum(x, y: TNumber): TNumber;
Var i: LongInt;
Begin
  While x.n<y.n Do Begin
    Inc(x.n);
    x.d[x.n]:= 0;
  End;
  For i:= 0 To y.n Do Begin
    Inc (x.d[i], y.d[i]);
  End;
  NormalizeToBin3(x);
  Sum:= x;
End;

Function Mult(x, y: TNumber): TNumber;
Var z: TNumber;
    i, j: LongInt;
Begin
  z.n:= x.n+y.n;
  For i:= 0 To z.n Do Begin
    z.d[i]:= 0;
  End;
  For i:= 0 To x.n Do Begin
    If x.d[i]=1 Then Begin
      For j:= 0 To y.n Do Begin
        Inc (z.d[i+j], y.d[j])
      End;
    End
    Else Begin
      If x.d[i]=-1 Then Begin
        For j:= 0 To y.n Do Begin
          Dec (z.d[i+j], y.d[j])
        End;
      End;
    End;
  End;
  NormalizeToBin3(z);
  Mult:= z;
End;

Procedure PutBin(var f: Text; x: Tnumber);
Var i: LongInt;
Begin
  If x.d[x.n]=-1 Then Begin
    Write(f, '-');
    For i:= 0 To x.n Do Begin
      x.d[i]:= -x.d[i];
    End;
  End;
  For i:= 0 To x.n Do Begin
    If x.d[i]<0 Then Begin
      Case x.d[i] of
      -1: x.d[i]:= 1;
      -2: x.d[i]:= 0;
      End {Case};
      Dec(x.d[i+1]);
    End;
  End;
  While (x.n>0) and (x.d[x.n]=0) Do Begin
    Dec(x.n);
  End;
  For i:= x.n DownTo 0 Do Begin
    Write(f,x.d[i]);
  End;
  Writeln(f);
End;

Function Compare(x,y: TNumber): Char;
Begin
  While x.n<y.n Do Begin
    Inc(x.n);
    x.d[x.n]:= 0;
  End;
  While y.n<x.n Do Begin
    Inc(y.n);
    y.d[y.n]:= 0;
  End;
  While (x.n>=0) and (x.d[x.n]=y.d[y.n]) Do Begin
    Dec(x.n);
    Dec(y.n);
  End;
  If (x.n<0) Then Compare:= '='
  Else
  If x.d[x.n]<y.d[y.n] Then Compare:= '<'
  Else
  If x.d[x.n]>y.d[y.n] Then Compare:= '>';
End;

Var a, b: TNumber;
    f: Text;
Begin
  Assign(f,'bin3.in'); Reset(f);
  a:= GetN(f);
  b:= GetN(f);
  Close(f);
  Assign(f,'bin3.out'); Rewrite(f);
{Part 1. Comparision}
  Writeln(f, Compare(a,b));
{Part 2. Addition}
  PutN (f, Sum(a,b));
{Part 3. Multiplication}
  PutN (f, Mult(a,b));
{Part 4. Convert to binary}
  PutBin (f, a);
  Close(f);
End.
